% simulacija oscilatora sa vinovim mostom

astop = 10*2*pi;
astep = 0.05*pi/180;

nstep = astop/astep;

h = astep;

vc1(1)=0.01;
vc2(1)=0;

c1=1;
c2=2;

while c1 < nstep

	vo(c1)=vout(vc1(c1));
	vc1(c2)=vc1(c1)+h*(-2*vc1(c1)-vc2(c1)+vo(c1));
	vc2(c2)=vc2(c1)+h*(-vc1(c1)-vc2(c1)+vo(c1));
	c1=c2;
	c2=c2+1;
	
end

vo(c1)=vout(vc1(c1));

trel=(1:c1)*astep/2/pi;

ic=[vc1(c1), vc2(c1)]
save ic ic

figure(1)
subplot(2,1,1)
plot(trel,vc1)
axis([0 10 -10 10])
xlabel('t/T_0')
ylabel('v_{C1} [V]')
subplot(2,1,2)
plot(trel,vc2)
axis([0 10 -10 10])
xlabel('t/T_0')
ylabel('v_{C2} [V]')

figure(2)
plot(vc1,vc2)
axis([-10 10 -10 10],"square")
xlabel('v_{C1} [V]')
ylabel('v_{C2} [V]')

figure(3)
plot(trel,vo)
axis([0 10 -15 15])
xlabel('t/T_0')
ylabel('v_{OUT} [V]')

figure(4)
plot(vc1,vo)
hold on
plot(vc1,3*vc1,'r')
axis([-6 6 -18 18])
xlabel('v_{C1} [V]')
ylabel('v_{OUT} [V] (blue), 3*v_{C1} [V] (red)')
hold off

print(1,"vc1vc2.ps","-depsc2")
print(2,"phaseplane.ps","-depsc2")
print(3,"vout.ps","-depsc2")
print(4,"amplituda.ps","-depsc2")

dat=[trel' vc1' vc2' vo' 3*vc1'];
save dat dat

